/*+
|                                               |
|     Trigger: DTULTATU_ITEMTRAB                |  
|     Tabela : ITEMTRAB                         |
|                                               |
|     Criao:                                  |
|     23/07/2007 - Danilo dos Anjos Faria       |
|                                               |
+*/


CREATE OR REPLACE TRIGGER DTULTATU_ITEMTRAB
BEFORE INSERT OR UPDATE OR DELETE
ON ITEMTRAB FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUITTR := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF ((NVL(:OLD.CDITEMTRAB,   0) <> NVL(:NEW.CDITEMTRAB,  0)) OR
           (NVL(:OLD.NMITEMTRAB,  0) <> NVL(:NEW.NMITEMTRAB,  0)) OR
           (NVL(:OLD.IDTPITEMTRAB,0) <> NVL(:NEW.IDTPITEMTRAB,0)) OR
           (NVL(:OLD.IDITTRABCONF,0) <> NVL(:NEW.IDITTRABCONF,0)) OR
           (NVL(:OLD.CDARVITTRAB, 0) <> NVL(:NEW.CDARVITTRAB, 0)) OR
           (NVL(:OLD.CDNVITEMTRAB,0) <> NVL(:NEW.CDNVITEMTRAB,0)) OR
           (NVL(:OLD.NMITTRABESPA,0) <> NVL(:NEW.NMITTRABESPA,0)) OR          
           (NVL(:OLD.NMIITRABINGL,0) <> NVL(:NEW.NMIITRABINGL,0)) OR
           (NVL(:OLD.NMITTRABINGL,0) <> NVL(:NEW.NMITTRABINGL,0)) OR
           (NVL(:OLD.CDREDUITTRAB,0) <> NVL(:NEW.CDREDUITTRAB,0)) OR
           (NVL(:OLD.NRCPLXITTRAB,0) <> NVL(:NEW.NRCPLXITTRAB,0)) OR
           (NVL(:OLD.CDTIPOITTRAB,0) <> NVL(:NEW.CDTIPOITTRAB,0)) OR
           (NVL(:OLD.DSDIRARQFONT,0) <> NVL(:NEW.DSDIRARQFONT,0)) OR
           (NVL(:OLD.IDSTCHECKOUT,0) <> NVL(:NEW.IDSTCHECKOUT,0))) THEN
           :NEW.DTULTATUITTR := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
      VALUES ('ITEMTRAB'  , '', 'CDITEMTRAB='||:OLD.CDITEMTRAB||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE ITEMTRAB MODIFY DTULTATUITTR DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_ITEMTRAB','4.11.160'); END;
/

